//  cnv_func.c
//
//	YUV to NV12 convert functions
//
//	Copyright (c) 2005 N099
//
#include <string.h>
#include <mmintrin.h>
#include "cnv_func.h"

/*
 * YV12 -> NV12
 *
 * unsigned char *pBufferOut : o̓obt@ւ̃|C^
 * unsigned char *pBufferIn  : ̓obt@ւ̃|C^
 * long swIn        : ̓C[W̕(+XgCh)
 * long Height      : o̓C[W̍
 * long swOut       : o̓C[W̕(+XgCh)
 * long Width       : ۂɃRs[镝
 */
void yv12_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn, 
				 long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	const long hWidth = Width >> 1;
	const long hHeight = Height >> 1;
	const long offsYV = (swIn * Height)>> 2;
	unsigned char *tmp_pBufferIn;
	unsigned char *tmp_pBufferOut;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		memcpy(pBufferOut, pBufferIn, Width);
		pBufferOut += swOut;
		pBufferIn  += swIn;
	}
	
	tmp_pBufferOut = pBufferOut;
	tmp_pBufferIn  = pBufferIn;

	//UYC^[[uȂRs[
	for(i=0; i<hHeight; ++i) {
		for(j=0; j<hWidth; ++j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
		tmp_pBufferOut += swOut;
		tmp_pBufferIn  += swIn>>1;
		pBufferOut = tmp_pBufferOut;
		pBufferIn  = tmp_pBufferIn;
	}
	
}

/*
 * YV12 -> NV12
 *
 *@MMXp
 */
void mmx_yv12_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn,
					 long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	const long hWidth = Width >> 1;
	const long hHeight = Height >> 1;
	const long offsYV = (swIn * Height)>> 2;
	unsigned char *tmp_pBufferIn;
	unsigned char *tmp_pBufferOut;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		memcpy(pBufferOut, pBufferIn, Width);
		pBufferOut += swOut;
		pBufferIn  += swIn;
	}
	
	tmp_pBufferOut = pBufferOut;
	tmp_pBufferIn  = pBufferIn;

	//UYC^[[uȂRs[
	for(i=0; i<hHeight; ++i) {
		for(j=hWidth; j>7; j-=8) {
			__m64 u0,v0,v1;
			u0 = *(__m64 *)(pBufferIn + offsYV);
			v0 = *(__m64 *)pBufferIn;
			v1 = v0;
			v0 = _mm_unpackhi_pi8(u0, v0);
			v1 = _mm_unpacklo_pi8(u0, v1);
			*(__m64 *)pBufferOut = v1;
			pBufferOut += 8;
			*(__m64 *)pBufferOut = v0;
			pBufferOut += 8;
			pBufferIn += 8;
		}
		for( ; j>0; --j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
		tmp_pBufferOut += swOut;
		tmp_pBufferIn  += swIn>>1;
		pBufferOut = tmp_pBufferOut;
		pBufferIn  = tmp_pBufferIn;
	}
	_mm_empty();
}


/*
 * YUY2 -> NV12
 * vObVuȉ摜p
 *
 * (1,7,7,1)/16  4tap tB^[
 *
 */
void yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn, 
				 long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=0; j<Width; ++j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		i1 = pBufferIn + 1;
		i2 = i1 + swIn;
		i0 = (i==0) ? i1 : i1 - swIn;
		i3 = (i >= hHeight-1) ? i2 : i2 + swIn;

		for(j=0; j<Width; ++j) {
			k = (*i1 + *i2) * 7 + (*i0 + *i3) + 8;
			k >>= 4; 
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn + swIn;
	}
	
}

/*
 * YUY2 -> NV12
 * vObVuȉ摜p MMX
 *
 * (1,7,7,1)/16  4tap tB^[
 *
 */
void mmx_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn,
					 long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;
	__m64 m0,m1,m2,m3,mm;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;

	//ỸRs[
	mm = _mm_setzero_si64();
	mm = _mm_cmpeq_pi8(mm, mm);
	mm = _mm_srli_pi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=Width; j>7; j-=8) {
			m0 = _mm_and_si64(*(__m64 *)i0,       mm);
			m1 = _mm_and_si64(*(__m64 *)(i0 + 8), mm);
			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m0, m1);
			tmp_pBufferOut += 8;
			i0 += 16;
		}
		for( ; j>0; --j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	mm = _mm_srli_pi16(mm, 7);
	mm = _mm_slli_pi16(mm, 3);
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		i1 = pBufferIn;
		i2 = i1 + swIn;
		i0 = (i==0) ? i1 : i1 - swIn;
		i3 = (i >= hHeight-1) ? i2 : i2 + swIn;

		for(j=Width; j>7; j-=8) {
			//1st
			// +
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m0 = _mm_add_pi16(m0, m1);
			// *7
			m2 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m2 = _mm_add_pi16(m2, m1);
			m1 = _mm_slli_pi16(m2, 3);
			m1 = _mm_sub_pi16(m1, m2);
			// +8
			m0 = _mm_add_pi16(m0, mm);
			m0 = _mm_add_pi16(m0, m1);
			m3 = _mm_srli_pi16(m0, 4);
			//
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
			//2nd
			// +
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m0 = _mm_add_pi16(m0, m1);
			// *7
			m2 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m2 = _mm_add_pi16(m2, m1);
			m1 = _mm_slli_pi16(m2, 3);
			m1 = _mm_sub_pi16(m1, m2);
			// +8
			m0 = _mm_add_pi16(m0, mm);
			m0 = _mm_add_pi16(m0, m1);
			m0 = _mm_srli_pi16(m0, 4);

			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m3, m0);
			tmp_pBufferOut += 8;
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
		}
		//c Y1Tvi߂
		++i0;
		++i1;
		++i2;
		++i3;
		for( ; j>0; --j) {
			k = (*i1 + *i2) * 7 + (*i0 + *i3) + 8;
			k >>= 4; 
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn + swIn;
	}
	_mm_empty();
}


/*
 * YUY2 -> NV12
 * C^[[X(FTvʒu)ȉ摜p
 *
 * (-1,9,9,-1)/16  4tap tB^[ivtB^Ȃ̕ԁj
 *
 */
void ix_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn, 
					long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	long swIn2;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;
	swIn2 = swIn * 2;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=0; j<Width; ++j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYԂȂRs[
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1){ //{g
			i2 = pBufferIn + 1 + swIn;
			i1 = i2 - swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}else{ //gbv
			i1 = pBufferIn + 1;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=0; j<Width; ++j) {
			k = (*i1 + *i2) * 9 - (*i0 + *i3) + 8;
			k = k>0 ? (k >> 4) : 0;
			k  = k>255 ? 255 : k;
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	
}

/*
 * YUY2 -> NV12
 * C^[[X(FTvʒu)ȉ摜p MMX
 *
 * (-1,9,9,-1)/16  4tap tB^[ivtB^Ȃ̕ԁj
 *
 */
void mmx_ix_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn,
						long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	long swIn2;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;
	__m64 m0,m1,m2,m3,mm;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;
	swIn2 = swIn * 2;

	//ỸRs[
	mm = _mm_setzero_si64();
	mm = _mm_cmpeq_pi8(mm, mm);
	mm = _mm_srli_pi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=Width; j>7; j-=8) {
			m0 = _mm_and_si64(*(__m64 *)i0,       mm);
			m1 = _mm_and_si64(*(__m64 *)(i0 + 8), mm);
			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m0, m1);
			tmp_pBufferOut += 8;
			i0 += 16;
		}
		for( ; j>0; --j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYԂȂRs[
	mm = _mm_srli_pi16(mm, 7);
	mm = _mm_slli_pi16(mm, 3);
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1){ //{g
			i2 = pBufferIn + swIn;
			i1 = i2 - swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}else{ //gbv
			i1 = pBufferIn;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=Width; j>7; j-=8) {
			//1st
			// -
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m0 = _mm_add_pi16(m0, m1);
			// *9
			m2 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m2 = _mm_add_pi16(m2, m1);
			m1 = _mm_slli_pi16(m2, 3);
			m1 = _mm_add_pi16(m1, m2);
			// +8
			m1 = _mm_add_pi16(m1, mm);
			m1 = _mm_sub_pi16(m1, m0);
			m3 = _mm_srli_pi16(m1, 4);
			//
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
			//2nd
			// -
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m0 = _mm_add_pi16(m0, m1);
			// *9
			m2 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m2 = _mm_add_pi16(m2, m1);
			m1 = _mm_slli_pi16(m2, 3);
			m1 = _mm_add_pi16(m1, m2);
			// +8
			m1 = _mm_add_pi16(m1, mm);
			m1 = _mm_sub_pi16(m1, m0);
			m1 = _mm_srli_pi16(m1, 4);

			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m3, m1);
			tmp_pBufferOut += 8;
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
		}
		//c Y1Tvi߂
		++i0;
		++i1;
		++i2;
		++i3;
		for( ; j>0; --j) {
			k = (*i1 + *i2) * 9 - (*i0 + *i3) + 8;
			k = k>0 ? (k >> 4) : 0;
			k  = k>255 ? 255 : k;
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	_mm_empty();
}


/*
 * YUY2 -> NV12
 * C^[[X(FTvʒuMPEG2)ȉ摜p
 *
 * (-5,55,15,-1)/64  4tap tB^[ivtB^Ȃ̕ԁj
 *
 */
void i_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn, 
					long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	long swIn2;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;
	swIn2 = swIn * 2;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=0; j<Width; ++j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYԂȂRs[
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1){ //{g
			i1 = pBufferIn + 1 + swIn;
			i2 = i1 - swIn2;
			i3 = (i<2) ? i2 : i2 - swIn2;
			i0 = (i >= hHeight-2) ? i1 : i1 + swIn2;
		}else{ //gbv
			i1 = pBufferIn + 1;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=0; j<Width; ++j) {
			k  = 55 * *i1 + 15 * *i2;
			k -=  5 * *i0 +      *i3;
			k += 32;
			k  = k>0 ? (k >> 6) : 0;
			k  = k>255 ? 255 : k;
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	
}

/*
 * YUY2 -> NV12
 * C^[[X(FTvʒuMPEG2)ȉ摜p MMX
 *
 * (-5,55,15,-1)/64  4tap tB^[ivtB^Ȃ̕ԁj
 *
 */
void mmx_i_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn,
						long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	long swIn2;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;
	__m64 m0,m1,m2,m3,mm,mr;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;
	swIn2 = swIn * 2;

	//ỸRs[
	mm = _mm_setzero_si64();
	mm = _mm_cmpeq_pi8(mm, mm);
	mm = _mm_srli_pi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=Width; j>7; j-=8) {
			m0 = _mm_and_si64(*(__m64 *)i0,       mm);
			m1 = _mm_and_si64(*(__m64 *)(i0 + 8), mm);
			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m0, m1);
			tmp_pBufferOut += 8;
			i0 += 16;
		}
		for( ; j>0; --j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYԂȂRs[
	mr = _mm_srli_pi16(mm, 7);
	mr = _mm_slli_pi16(mr, 5);
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1){ //{g
			i1 = pBufferIn + swIn;
			i2 = i1 - swIn2;
			i3 = (i<2) ? i2 : i2 - swIn2;
			i0 = (i >= hHeight-2) ? i1 : i1 + swIn2;
		}else{ //gbv
			i1 = pBufferIn;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=Width; j>7; j-=8) {
			//1st
			// -*5
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m3 = _mm_slli_pi16(m0, 2); //*4
			m0 = _mm_add_pi16(m0, m3); //+1
			// *55
			m1 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m3 = _mm_slli_pi16(m1, 6); //*64
			m3 = _mm_sub_pi16(m3, m1); //-1
			m1 = _mm_slli_pi16(m1, 3); //*8
			m3 = _mm_sub_pi16(m3, m0);
			m0 = _mm_sub_pi16(m3, m1);
			// *15
			m2 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m1 = _mm_slli_pi16(m2, 4); //*16
			m1 = _mm_sub_pi16(m1, m2); //-1
			// -*1
			m3 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m1 = _mm_sub_pi16(m1, m3);
			// +32
			m0 = _mm_add_pi16(m0, mr);
			m0 = _mm_add_pi16(m0, m1);
			mm = _mm_srli_pi16(m0, 6);
			//
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
			//2nd
			// -*5
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m3 = _mm_slli_pi16(m0, 2); //*4
			m0 = _mm_add_pi16(m0, m3); //+1
			// *55
			m1 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m3 = _mm_slli_pi16(m1, 6); //*64
			m3 = _mm_sub_pi16(m3, m1); //-1
			m1 = _mm_slli_pi16(m1, 3); //*8
			m3 = _mm_sub_pi16(m3, m0);
			m0 = _mm_sub_pi16(m3, m1);
			// *15
			m2 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m1 = _mm_slli_pi16(m2, 4); //*16
			m1 = _mm_sub_pi16(m1, m2); //-1
			// -*1
			m3 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m1 = _mm_sub_pi16(m1, m3);
			// +32
			m0 = _mm_add_pi16(m0, mr);
			m0 = _mm_add_pi16(m0, m1);
			m0 = _mm_srli_pi16(m0, 6);

			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(mm, m0);
			tmp_pBufferOut += 8;
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
		}
		//c Y1Tvi߂
		++i0;
		++i1;
		++i2;
		++i3;
		for( ; j>0; --j) {
			k  = 55 * *i1 + 15 * *i2;
			k -=  5 * *i0 +      *i3;
			k += 32;
			k  = k>0 ? (k >> 6) : 0;
			k  = k>255 ? 255 : k;
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	_mm_empty();
}

/*
 * YUY2 -> NV12
 * C^[[X(FTvʒu)ȉ摜p
 *
 * (1,7,7,1)/16  4tap tB^[ivtB^{TuTvj
 *
 */
void ixq_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn, 
					 long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	long swIn2;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;
	swIn2 = swIn * 2;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=0; j<Width; ++j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1){ //{g
			i2 = pBufferIn + 1 + swIn;
			i1 = i2 - swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}else{ //gbv
			i1 = pBufferIn + 1;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=0; j<Width; ++j) {
			k = (*i1 + *i2) * 7 + (*i0 + *i3) + 8;
			k >>= 4;
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	
}

/*
 * YUY2 -> NV12
 * C^[[X(FTvʒu)ȉ摜p MMX
 *
 * (1,7,7,1)/16  4tap tB^[ivtB^{TuTvj
 *
 */
void mmx_ixq_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn,
						 long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	long swIn2;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;
	__m64 m0,m1,m2,m3,mm;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;
	swIn2 = swIn * 2;

	//ỸRs[
	mm = _mm_setzero_si64();
	mm = _mm_cmpeq_pi8(mm, mm);
	mm = _mm_srli_pi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=Width; j>7; j-=8) {
			m0 = _mm_and_si64(*(__m64 *)i0,       mm);
			m1 = _mm_and_si64(*(__m64 *)(i0 + 8), mm);
			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m0, m1);
			tmp_pBufferOut += 8;
			i0 += 16;
		}
		for( ; j>0; --j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	mm = _mm_srli_pi16(mm, 7);
	mm = _mm_slli_pi16(mm, 3);
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1){ //{g
			i2 = pBufferIn + swIn;
			i1 = i2 - swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}else{ //gbv
			i1 = pBufferIn;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=Width; j>7; j-=8) {
			//1st
			// *1
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m0 = _mm_add_pi16(m0, m1);
			// *7
			m2 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m2 = _mm_add_pi16(m2, m1);
			m1 = _mm_slli_pi16(m2, 3); //*8
			m1 = _mm_sub_pi16(m1, m2); //-1
			// +8
			m1 = _mm_add_pi16(m1, mm);
			m1 = _mm_add_pi16(m1, m0);
			m3 = _mm_srli_pi16(m1, 4);
			//
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
			//2nd
			// *1
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m0 = _mm_add_pi16(m0, m1);
			// *7
			m2 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m1 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m2 = _mm_add_pi16(m2, m1);
			m1 = _mm_slli_pi16(m2, 3); //*8
			m1 = _mm_sub_pi16(m1, m2); //-1
			// +8
			m1 = _mm_add_pi16(m1, mm);
			m1 = _mm_add_pi16(m1, m0);
			m1 = _mm_srli_pi16(m1, 4);

			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m3, m1);
			tmp_pBufferOut += 8;
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
		}
		//c Y1Tvi߂
		++i0;
		++i1;
		++i2;
		++i3;
		for( ; j>0; --j) {
			k = (*i1 + *i2) * 7 + (*i0 + *i3) + 8;
			k >>= 4;
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	_mm_empty();
}


/*
 * YUY2 -> NV12
 * C^[[X(FTvʒuMPEG2)ȉ摜p
 *
 * (5,15,11,1)/32  4tap tB^[ivtB^{TuTvj
 *
 */
void iq_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn, 
					long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	long swIn2;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;
	swIn2 = swIn * 2;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=0; j<Width; ++j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1){ //{g
			i1 = pBufferIn + 1 + swIn;
			i2 = i1 - swIn2;
			i3 = (i<2) ? i2 : i2 - swIn2;
			i0 = (i >= hHeight-2) ? i1 : i1 + swIn2;
		}else{ //gbv
			i1 = pBufferIn + 1;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=0; j<Width; ++j) {
			k  = 15 * *i1 + 11 * *i2;
			k +=  5 * *i0 +      *i3;
			k += 16;
			k >>= 5;
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	
}

/*
 * YUY2 -> NV12
 * C^[[X(FTvʒuMPEG2)ȉ摜p MMX
 *
 * (5,15,11,1)/32  4tap tB^[ivtB^{TuTvj
 *
 */
void mmx_iq_yuy2_2_nv12(unsigned char *pBufferOut, unsigned char *pBufferIn,
						long swIn, long Height, long swOut, long Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j,k;
	long hHeight = Height >> 1;
	long swIn2;
	unsigned char *tmp_pBufferIn = pBufferIn;
	unsigned char *tmp_pBufferOut;
	unsigned char *i0,*i1,*i2,*i3;
	__m64 m0,m1,m2,m3,mm,mr;

	//swIn̓sNZPʂȂ̂2{Ă
	swIn *= 2;
	swIn2 = swIn * 2;

	//ỸRs[
	mm = _mm_setzero_si64();
	mm = _mm_cmpeq_pi8(mm, mm);
	mm = _mm_srli_pi16(mm, 8);
	for(i=0; i<Height; ++i) {
		tmp_pBufferOut = pBufferOut;
		i0 = tmp_pBufferIn;
		for(j=Width; j>7; j-=8) {
			m0 = _mm_and_si64(*(__m64 *)i0,       mm);
			m1 = _mm_and_si64(*(__m64 *)(i0 + 8), mm);
			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(m0, m1);
			tmp_pBufferOut += 8;
			i0 += 16;
		}
		for( ; j>0; --j) {
			*tmp_pBufferOut = *i0;
			tmp_pBufferOut++;
			i0 += 2;
		}
		pBufferOut    += swOut;
		tmp_pBufferIn += swIn;
	}

	//UYTuTvȂRs[
	mr = _mm_srli_pi16(mm, 7);
	mr = _mm_slli_pi16(mr, 4);
	for(i=0; i<hHeight; ++i) {
		tmp_pBufferOut = pBufferOut;
		if(i&1){ //{g
			i1 = pBufferIn + swIn;
			i2 = i1 - swIn2;
			i3 = (i<2) ? i2 : i2 - swIn2;
			i0 = (i >= hHeight-2) ? i1 : i1 + swIn2;
		}else{ //gbv
			i1 = pBufferIn;
			i2 = i1 + swIn2;
			i0 = (i<2) ? i1 : i1 - swIn2;
			i3 = (i >= hHeight-2) ? i2 : i2 + swIn2;
		}

		for(j=Width; j>7; j-=8) {
			//1st
			// *5
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m3 = _mm_slli_pi16(m0, 2); //*4
			m0 = _mm_add_pi16(m0, m3); //+1
			// *15
			m1 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m3 = _mm_slli_pi16(m1, 4); //*16
			m3 = _mm_sub_pi16(m3, m1); //-1
			m0 = _mm_add_pi16(m0, m3);
			// *11
			m2 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m1 = _mm_slli_pi16(m2, 3); //*8
			m3 = _mm_slli_pi16(m2, 2); //*4
			m1 = _mm_sub_pi16(m1, m2); //-1
			m3 = _mm_add_pi16(m3, m1);
			// *1
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m1 = _mm_add_pi16(m1, m3);
			// +16
			m0 = _mm_add_pi16(m0, mr);
			m0 = _mm_add_pi16(m0, m1);
			mm = _mm_srli_pi16(m0, 5);
			//
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
			//2nd
			// *5
			m0 = _mm_srli_pi16(*(__m64 *)i0, 8);
			m3 = _mm_slli_pi16(m0, 2); //*4
			m0 = _mm_add_pi16(m0, m3); //+1
			// *15
			m1 = _mm_srli_pi16(*(__m64 *)i1, 8);
			m3 = _mm_slli_pi16(m1, 4); //*16
			m3 = _mm_sub_pi16(m3, m1); //-1
			m0 = _mm_add_pi16(m0, m3);
			// *11
			m2 = _mm_srli_pi16(*(__m64 *)i2, 8);
			m1 = _mm_slli_pi16(m2, 3); //*8
			m3 = _mm_slli_pi16(m2, 2); //*4
			m1 = _mm_sub_pi16(m1, m2); //-1
			m3 = _mm_add_pi16(m3, m1);
			// *1
			m1 = _mm_srli_pi16(*(__m64 *)i3, 8);
			m1 = _mm_add_pi16(m1, m3);
			// +16
			m0 = _mm_add_pi16(m0, mr);
			m0 = _mm_add_pi16(m0, m1);
			m0 = _mm_srli_pi16(m0, 5);

			*(__m64 *)tmp_pBufferOut = _mm_packs_pu16(mm, m0);
			tmp_pBufferOut += 8;
			i0 += 8;
			i1 += 8;
			i2 += 8;
			i3 += 8;
		}
		//c Y1Tvi߂
		++i0;
		++i1;
		++i2;
		++i3;
		for( ; j>0; --j) {
			k  = 15 * *i1 + 11 * *i2;
			k +=  5 * *i0 +      *i3;
			k += 16;
			k >>= 5;
			*tmp_pBufferOut = (unsigned char)k;
			tmp_pBufferOut++;
			i0 += 2;
			i1 += 2;
			i2 += 2;
			i3 += 2;
		}
		pBufferOut += swOut;
		pBufferIn  += swIn2;
	}
	_mm_empty();
}

