//  yuv2nv12.cpp
//
//	YUV to NV12 converter
//
//	Copyright (c) 2005 N099
//

#define WIN32_LEAN_AND_MEAN // Windows wb_[gpĂȂO܂B
// Windows wb_[ t@C :
#include <windows.h>

#include <streams.h>
#include <dvdmedia.h>
#include <aviriff.h> 
#include <initguid.h>
#include "defs.h"
#include "reg.h"
#include "yuv2nv12.h"
#include "cnv_func.h"

// s̒`
REGPINTYPES sudOutputTypes = { &MEDIATYPE_Video, &MEDIASUBTYPE_NV12 };
REGPINTYPES sudInputTypes[] = {
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_YV12 },
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_YUY2 }
};

// s錾B
REGFILTERPINS sudPinReg[] = {
    // ̓sB
    { 0, FALSE, // Rendered?
         FALSE, // Output?
         FALSE, // Zero?
         FALSE, // Many?
         0, 0, 
         2, sudInputTypes  // Media types.
    },
    // o̓sB
    { 0, FALSE, // _OĂ邩?
         TRUE, // o?
         FALSE, // [?
         FALSE, // ?
         0, 0, 
         1, &sudOutputTypes      // fBA ^CvB
    }
};
 
// tB^錾B
REGFILTER2 rf2FilterReg = {
    1,                // o[WԍB
    MERIT_DO_NOT_USE, // bgB
    2,                // s̐B
    sudPinReg         // sւ̃|C^B
};


//tB^
static WCHAR g_wszName[] = L"YUV to NV12 converter";

CFactoryTemplate g_Templates[] = 
{
  { 
    g_wszName,
    &CLSID_YUV2NV12,
    Cyuv2nv12::CreateInstance,
    NULL,
    NULL
  }
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);


//dllGg|Cg
extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}


//constructor
Cyuv2nv12::Cyuv2nv12(TCHAR *tszName, LPUNKNOWN punk)
	: CTransformFilter(tszName, punk, CLSID_YUV2NV12)
{ 
	interlace = format_in = 0;
	height = width_in = width_in_s = width_out = width_out_s = 0;
	LoadRegistryInfo(&conf);
	if(!isMMXavailable())
		conf.use_mmx = 0;

	//DbgSetModuleLevel(LOG_TRACE, 2);
}

//CreateInstance
CUnknown *Cyuv2nv12::CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr)
{
	Cyuv2nv12 *pFilter = new Cyuv2nv12(NAME("YUV to NV12 converter"), pUnk);
	if (pFilter== NULL) 
	{
		*pHr = E_OUTOFMEMORY;
	}
	return pFilter;
}


//͂̃`FbN
HRESULT Cyuv2nv12::CheckInputType(const CMediaType *mtIn)
{
	if(mtIn->majortype != MEDIATYPE_Video){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	BITMAPINFOHEADER *pbmi = GetBmiHeader(*mtIn);
	if (NULL == pbmi)
	{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

	//J[tH[}bg̃`FbN
	if(mtIn->subtype == MEDIASUBTYPE_YV12){
		if(pbmi->biCompression != FCC('YV12'))
			return VFW_E_TYPE_NOT_ACCEPTED;

	}else if(mtIn->subtype == MEDIASUBTYPE_YUY2){
		if(pbmi->biCompression != FCC('YUY2'))
			return VFW_E_TYPE_NOT_ACCEPTED;

	}else{
		return VFW_E_TYPE_NOT_ACCEPTED;
	}
	
	DisplayType(NAME("Cyuv2nv12::CheckInputType()"), mtIn);

	//㗬̃tH[}bgύXɑΉ
	ASSERT(m_pOutput);
	if(m_pOutput->IsConnected() && m_pInput->IsConnected()){
		//VIDEOINFOHEADER2ŒǉꂽtO̕ύX݂̂
		CMediaType cmtIn_cur(m_pInput->CurrentMediaType());
		if(FORMAT_VideoInfo2 == cmtIn_cur.formattype){
			VIDEOINFOHEADER2 *vifIn, *vifIn_cur;
			CMediaType cmtIn(*mtIn);
			vifIn = reinterpret_cast<VIDEOINFOHEADER2*>(cmtIn.pbFormat);
			vifIn_cur = reinterpret_cast<VIDEOINFOHEADER2*>(cmtIn_cur.pbFormat);
			//wb_̈ꕔڂ̂݁AύX
			CopySubsetVIF2Flag(vifIn, vifIn_cur);

			if(cmtIn == cmtIn_cur){
				CMediaType cmtOut(m_pOutput->CurrentMediaType());
				VIDEOINFOHEADER2 *vifOut = reinterpret_cast<VIDEOINFOHEADER2*>(cmtOut.pbFormat);
				vifIn = reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->pbFormat);

				//ύXZbgAtB^ɖ₢킹
				CopySubsetVIF2Flag(vifOut, vifIn);
				if(S_OK != m_pOutput->GetConnected()->QueryAccept(&cmtOut)){
					DbgLog((LOG_TRACE, 2, NAME("Cyuv2nv12::CheckInputType() QueryDS:FAIL")));
					return VFW_E_TYPE_NOT_ACCEPTED;
				}
				DbgLog((LOG_TRACE, 2, NAME("Cyuv2nv12::CheckInputType() QueryDS:OK")));
			}
		}else{
			return VFW_E_TYPE_NOT_ACCEPTED;
		}
	}

	// ׂĖȂB
	return S_OK;
}

//o͌`̒
HRESULT Cyuv2nv12::GetMediaType(int iPosition, CMediaType *pMediaType)
{
	ASSERT(m_pInput->IsConnected());
	if (iPosition < 0)
	{
		return E_INVALIDARG;
	}
	if (iPosition == 0)
	{
		HRESULT hr;
		hr = m_pInput->ConnectionMediaType(pMediaType);
		if (FAILED(hr))
		{
			return hr;
		}
		pMediaType->subtype = MEDIASUBTYPE_NV12;

		//BITMAPINFOHEADERł̃^Cvw
		BITMAPINFOHEADER *pbmi = GetBmiHeader(*pMediaType);
		if (NULL == pbmi)
		{
			return E_UNEXPECTED;
		}

		long h = abs(pbmi->biHeight);
		pbmi->biCompression = FCC('NV12');
		pbmi->biBitCount = 12;
		pbmi->biSizeImage = pbmi->biWidth * (h + ((h+1)>>1));

		return S_OK;
	}
	// else
	return VFW_S_NO_MORE_ITEMS;
}

//ڑ̃`FbN
HRESULT Cyuv2nv12::CheckTransform(
	const CMediaType *mtIn, const CMediaType *mtOut)
{
	BITMAPINFOHEADER *pbmiIn, *pbmiOut;
	RECT *prcSrc, *prcTarget;

	if (mtIn->formattype == FORMAT_VideoInfo && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER))
	{
		pbmiIn = &reinterpret_cast<VIDEOINFOHEADER*>(mtIn->pbFormat)->bmiHeader;
		prcSrc = &reinterpret_cast<VIDEOINFOHEADER*>(mtIn->pbFormat)->rcSource;
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2 && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2))
	{
		pbmiIn = &reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->pbFormat)->bmiHeader;
		prcSrc = &reinterpret_cast<VIDEOINFOHEADER2*>(mtIn->pbFormat)->rcSource;
	}else{
		return E_UNEXPECTED;
	}

	if (mtOut->formattype == FORMAT_VideoInfo && mtOut->cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmiOut   = &reinterpret_cast<VIDEOINFOHEADER*>(mtOut->Format())->bmiHeader;
		prcTarget = &reinterpret_cast<VIDEOINFOHEADER*>(mtOut->Format())->rcTarget;
	}
	else if (mtOut->formattype == FORMAT_VideoInfo2 && mtOut->cbFormat >= sizeof(VIDEOINFOHEADER2)){
		pbmiOut   = &reinterpret_cast<VIDEOINFOHEADER2*>(mtOut->Format())->bmiHeader;
		prcTarget = &reinterpret_cast<VIDEOINFOHEADER2*>(mtOut->Format())->rcTarget;
	}else{
		return E_UNEXPECTED;
	}
	//biWidth̓XgCh̒l
	long tmp_width_out_s = pbmiOut->biWidth;
	long tmp_width_in_s  = pbmiIn->biWidth;
	long tmp_height_out = abs(pbmiOut->biHeight);
	long tmp_height_in  = abs(pbmiIn->biHeight);
	long tmp_width_out = tmp_width_out_s;
	long tmp_width_in  = tmp_width_in_s;

	//قȂ邱Ƃ͂肦ȂEE
	if (tmp_height_out != tmp_height_in) {
		return VFW_E_INVALIDMEDIATYPE;
	}

	// ]`Ɠ]`rB
	// ܂Ӗ킩ĂȂB
	RECT rcImg;
	SetRect(&rcImg, 0, 0, tmp_width_in_s, tmp_height_in);
	if (IsRectEmpty(prcSrc) || EqualRect(prcSrc, &rcImg)) {
		// XgChlȂĂ悢ꍇ
		tmp_width_in = tmp_width_in_s;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcSrc->right;
		// ̓f[^̃XgChl
		if(!EqualRect(prcSrc, &rcImg2) || rcImg2.right>tmp_width_in_s) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		tmp_width_in = rcImg2.right;
	}

	SetRect(&rcImg, 0, 0, tmp_width_out_s, tmp_height_in);
	if (IsRectEmpty(prcTarget) || EqualRect(prcTarget, &rcImg)) {
		tmp_width_out = tmp_width_out_s;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcTarget->right;
		// o̓f[^̃XgChl
		if(!EqualRect(prcTarget, &rcImg2) || rcImg2.right>tmp_width_out_s) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		tmp_width_out = rcImg2.right;
	}

	//o͉摜̕ꉞ`FbN
	if (tmp_width_out != tmp_width_in) {
		return VFW_E_INVALIDMEDIATYPE;
	}

	//̓tH[}bgݒ
	int tmp_format_in = 0;
	if(mtIn->subtype == MEDIASUBTYPE_YV12){
		if(pbmiIn->biCompression == FCC('YV12'))
			tmp_format_in = FMT_YV12;
	}else if(mtIn->subtype == MEDIASUBTYPE_YUY2){
		if(pbmiIn->biCompression == FCC('YUY2'))
			tmp_format_in = FMT_YUY2;
	}
	if(0 == tmp_format_in){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}else{
		//ݒ𔽉f
		CAutoLock lck(&m_cs);
		height      = tmp_height_in;
		width_in    = tmp_width_in;
		width_in_s  = tmp_width_in_s;
		width_out   = tmp_width_out;
		width_out_s = tmp_width_out_s;
		format_in   = tmp_format_in;
	}

	DisplayType(NAME("Cyuv2nv12::CheckTransform():IN"), mtIn);
	DisplayType(NAME("Cyuv2nv12::CheckTransform():OUT"), mtOut);

	// ׂĖȂB
	return S_OK;
}

//CompleteConnect
HRESULT Cyuv2nv12::CompleteConnect(PIN_DIRECTION direction,IPin *pReceivePin)
{
	UNREFERENCED_PARAMETER(direction);
	UNREFERENCED_PARAMETER(pReceivePin);

	if(direction == PINDIR_INPUT && 0 == conf.connect_nv12){
		//㗬tB^NV12o͂ɑΉĂꍇ͐ڑȂ
		HRESULT hr;
		IEnumMediaTypes *pEnum = NULL;
		BOOL nv12 = false;

		hr = pReceivePin->EnumMediaTypes(&pEnum);
		if(S_OK == hr){
			AM_MEDIA_TYPE *pamt = NULL;
			while(1){
				hr = pEnum->Next(1, &pamt, NULL);
				if(S_OK == hr){
					if(pamt->subtype == MEDIASUBTYPE_NV12){
						nv12 = true;
						DeleteMediaType(pamt);
						break;
					}
					DeleteMediaType(pamt);
					pamt = NULL;
				}else if(VFW_E_ENUM_OUT_OF_SYNC == hr){
					pEnum->Reset();
				}else{
					break;
				}
			}
			pEnum->Release();
		}

		if(nv12) return E_FAIL;
	}

	return NOERROR;
}


HRESULT Cyuv2nv12::DecideBufferSize(
	IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp)
{
	CMediaType cmt;
	HRESULT hr = m_pOutput->ConnectionMediaType(&cmt);
	if (FAILED(hr))
	{
		return hr;
	}

	//BITMAPINFOHEADERTCY𓾂
	BITMAPINFOHEADER *pbmi = GetBmiHeader(cmt);
	if (NULL == pbmi){
		//ɂ͗Ȃ
		return E_UNEXPECTED;
	}
	//őH
	pProp->cbBuffer = DIBSIZE(*pbmi); 
	if (pProp->cbAlign == 0)
	{
		pProp->cbAlign = 1;
	}
	if (pProp->cBuffers == 0)
	{
		pProp->cBuffers = 1;
	}

	// AP[^ vpeBݒ肷B
	ALLOCATOR_PROPERTIES Actual;
	hr = pAlloc->SetProperties(pProp, &Actual);
	if (FAILED(hr)) 
	{
		return hr;
	}
	// ꍇAۂ̌ʂmFB
	if (pProp->cbBuffer > Actual.cbBuffer) 
	{
		return E_FAIL;
	}
	return S_OK;
}

//ۂ̕ϊ
HRESULT Cyuv2nv12::Transform(IMediaSample *pSource, IMediaSample *pDest)
{
	// _EXg[̃tH[}bgύXB
	CMediaType *pMT = NULL;
	HRESULT hr = pDest->GetMediaType((AM_MEDIA_TYPE**)&pMT);
	if (hr == S_OK)
	{
		DisplayType(NAME("Cyuv2nv12::Transform():from DOWN"), pMT);

		hr = m_pOutput->CheckMediaType(pMT);
		if(FAILED(hr))
		{
			DeleteMediaType(pMT);
			return E_FAIL;
		}
		// V^CvɂĎg̏o̓sɒʒmB
		m_pOutput->SetMediaType(pMT);
		DeleteMediaType(pMT);
	}

	// AbvXg[̃tH[}bgύXB
	pMT = NULL;
	hr = pSource->GetMediaType((AM_MEDIA_TYPE**)&pMT);
	if (hr == S_OK)
	{
		DisplayType(NAME("Cyuv2nv12::Transform():from UP"), pMT);

		hr = m_pInput->CheckMediaType(pMT);
		if(FAILED(hr))
		{
			DeleteMediaType(pMT);
			return E_FAIL;
		}
		// V^Cv]ɃZbg
		CMediaType cmtOut(m_pOutput->CurrentMediaType());
		VIDEOINFOHEADER2 *vifOut = reinterpret_cast<VIDEOINFOHEADER2*>(cmtOut.pbFormat);
		VIDEOINFOHEADER2 *vifIn  = reinterpret_cast<VIDEOINFOHEADER2*>(pMT->pbFormat);
		CopySubsetVIF2Flag(vifOut, vifIn);
		hr = pDest->SetMediaType(&cmtOut);
		if(FAILED(hr))
		{
			DeleteMediaType(pMT);
			return E_FAIL;
		}

		// V^CvɂĎg̓̓sɒʒmB
		m_pInput->SetMediaType(pMT);
		DeleteMediaType(pMT);
	}

	// ɂȂobt@ւ̃|C^擾B
	BYTE *pBufferIn, *pBufferOut;
	hr = pSource->GetPointer(&pBufferIn);
	if (FAILED(hr))
	{
		return hr;
	}
	hr = pDest->GetPointer(&pBufferOut);
	if (FAILED(hr))
	{
		return hr;
	}

    // f[^B
	//CopyMemory(pBufferOut, pBufferIn, pSource->GetSize());
	Convert(pBufferOut, pBufferIn, pSource);

	//ۂ̃f[^ʒm
	pDest->SetActualDataLength((width_out_s + ((width_out_s + 1) >> 1)) * height);
	//L[t[łB
	pDest->SetSyncPoint(TRUE);

	return S_OK;
}

//ϊ֐
void Cyuv2nv12::Convert(BYTE *pBufferOut, BYTE *pBufferIn, IMediaSample *pSource)
{
	CAutoLock lck(&m_cs);

	if(format_in == FMT_YV12){
		if(conf.use_mmx){
			mmx_yv12_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
		}else{
			yv12_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
		}
	}else if(format_in == FMT_YUY2){
		CheckInterlace(pSource);
		if(interlace){ //C^
			if(0 == conf.i_sample_pos){ //FTvʒu:MPEG2iԁj
				if(conf.use_mmx)
					mmx_i_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
				else
					i_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
			}else if(1 == conf.i_sample_pos){ //FTvʒu:Siԁj
				if(conf.use_mmx)
					mmx_ix_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
				else
					ix_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
			}else if(2 == conf.i_sample_pos){ //FTvʒu:MPEG2ifV[Vj
				if(conf.use_mmx)
					mmx_iq_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
				else
					iq_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
			}else{ //FTvʒu:SifV[Vj
				if(conf.use_mmx)
					mmx_ixq_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
				else
					ixq_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
			}
		}else{ //vO
			if(conf.use_mmx)
				mmx_yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
			else
				yuy2_2_nv12(pBufferOut, pBufferIn, width_in_s, height, width_out_s, width_out);
		}
	}
}

//C^[[X/vObVu̔
HRESULT Cyuv2nv12::CheckInterlace(IMediaSample *pSource)
{
	// I/P
	if(conf.mode_ip){
		// I/PŒ
		interlace = conf.mode_ip >> 1;
	}else{
		// I/Pݒ
		interlace = 0;
		if(FORMAT_VideoInfo2 == m_pInput->CurrentMediaType().formattype
			&& m_pInput->CurrentMediaType().cbFormat >= sizeof(VIDEOINFOHEADER2))
		{
			VIDEOINFOHEADER2 *vif2 = 
				reinterpret_cast<VIDEOINFOHEADER2*>(m_pInput->CurrentMediaType().pbFormat);
			if(AMINTERLACE_IsInterlaced & vif2->dwInterlaceFlags){
				interlace = 1;
				//C^[[XtO`FbNAM_SAMPLE2_PROPERTIES𒲂ׂ
				IMediaSample2 *pIm2 = NULL;
				HRESULT hr = pSource->QueryInterface(IID_IMediaSample2, (void**)&pIm2);
				if(SUCCEEDED(hr)){
					AM_SAMPLE2_PROPERTIES am2;
					hr = pIm2->GetProperties(offsetof(AM_SAMPLE2_PROPERTIES, dwSampleFlags), (BYTE*)&am2);
					if(SUCCEEDED(hr)){
						if(am2.dwTypeSpecificFlags & AM_VIDEO_FLAG_WEAVE)
							interlace = 0;
					}
					pIm2->Release();
				}
			}
		}
	}

	return S_OK;
}

//BITMAPINFOHEADER𓾂
BITMAPINFOHEADER *Cyuv2nv12::GetBmiHeader(const CMediaType &cmt) const
{
	BITMAPINFOHEADER *pbmi;
	if (cmt.formattype == FORMAT_VideoInfo && cmt.cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmi = &reinterpret_cast<VIDEOINFOHEADER*>(cmt.pbFormat)->bmiHeader;
	} else if (cmt.formattype == FORMAT_VideoInfo2 && cmt.cbFormat >= sizeof(VIDEOINFOHEADER2)) {
		pbmi = &reinterpret_cast<VIDEOINFOHEADER2*>(cmt.pbFormat)->bmiHeader;
	} else {
		pbmi = NULL;
	}

	return pbmi;
}

//VIDEOINFOHEADER2̃tÖꕔRs[
void Cyuv2nv12::CopySubsetVIF2Flag(VIDEOINFOHEADER2 *dst, const VIDEOINFOHEADER2 *src) const
{
	//ȉ̍ڂ̂݁AύX
	dst->dwInterlaceFlags   = src->dwInterlaceFlags;
	dst->dwCopyProtectFlags = src->dwCopyProtectFlags;
	dst->dwPictAspectRatioX = src->dwPictAspectRatioX;
	dst->dwPictAspectRatioY = src->dwPictAspectRatioY;
	dst->dwControlFlags     = src->dwControlFlags;
}

//tB^̓o^
STDAPI DllRegisterServer(void)
{
	HRESULT hr = AMovieDllRegisterServer2(TRUE);
	if (FAILED(hr))
	{
		return hr;
	}
	IFilterMapper2 *pFM2 = NULL;
	hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
						IID_IFilterMapper2, (void **)&pFM2);
	if (SUCCEEDED(hr))
	{
		hr = pFM2->RegisterFilter(
			CLSID_YUV2NV12,           // tB^ CLSIDB
			g_wszName,                       // tB^B
			NULL,                            // foCX jJB
			&CLSID_LegacyAmFilterCategory,   // Dsf
			NULL,                       // CX^X f[^B
			&rf2FilterReg                    // tB^B
		);
		pFM2->Release();
	}
	return hr;
}

//tB^̓o^
STDAPI DllUnregisterServer()
{
	HRESULT hr = AMovieDllRegisterServer2(FALSE);
	if (FAILED(hr))
	{
		return hr;
	}
	IFilterMapper2 *pFM2 = NULL;
	hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
			IID_IFilterMapper2, (void **)&pFM2);
	if (SUCCEEDED(hr))
	{
		hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
			NULL, CLSID_YUV2NV12);
		pFM2->Release();
	}
	return hr;
}



